//    case 112:

 
void ProcessNBK()
{

  //#define KLP_NPG  0      // Номер клапана для управления НПГ (при дистилляции) 
  //#define KLP_VODA 1      // Номер клапана для управления общей подачей воды в систему
  //#define KLP_DEFL 2      // Номер клапана для подачи воды в дейфлегматор
  //#define KLP_GLV_HVS  3       // Номер клапана отбора головных и хвостовых фракций
  //#define KLP_SR   4      // Номер клапана отбора ректификата
  //#define TEMP_KUB  0      // Номер датчика  термометра в кубе
  //#define TEMP_RK20 1      // Номер датчика термометра в РК 20 см от насадки
  //#define TEMP_TSA  2      // Номер термометра в трубке связи с атмосферой
  if (flAlarmUroven && StateMachine<100) 
  { // Переводим автомат в стадию завершения 
    StateMachine=100;        
  }
  if (flAlarmMPX5010) StateMachine=100; // Переводим в режим тревоги по датчику давления

  switch  (StateMachine)
  {
  case 0: // Процесс не запущен
    break;
  case 1: // Начало процесса
    PrepareProcess();
    lastSMSState=0;
    KlOpen[KLP_VODA]=PER_KLP_OPEN;
    KlClose[KLP_VODA]=PER_KLP_CLOSE;
    StateMachine=2;
    if (BeepStateProcess) my_beep(BEEP_LONG);
    MaxPressByPeriod=0;
  case 2:
    UstPower=Power;
    digitalWrite(PIN_START_1,RELAY_HIGH);
    digitalWrite(PIN_START_2,RELAY_HIGH);
    if (temps[TEMP_DEFL]<TempDeflBegDistil  && ds1820_devices>1 || (TempDeflBegDistil<0 &&  temps[TEMP_KUB]<-TempDeflBegDistil)) break;
    KlOpen[KLP_HLD]=PER_KLP_OPEN;
    KlClose[KLP_HLD]=PER_KLP_CLOSE;
    StateMachine=3;
    if (BeepStateProcess) my_beep(BEEP_LONG);
  case 3:
    SpeedNBK=0;
    UstPower=PowerNBK;
    time1=20*60; // Задаем время 20 минут с начала старта
    time2=0;
    my_beep(BEEP_LONG*3);
    break;
  case 4:
    UstPower=PowerNBK;
    timeNBK=20;
    // Работаем в следующем режиме - 2 минуты пауза, 1 минута работает миксер.
    if (time3==0) 
    {  
       time3=((int) tempP[0]+ (int) timeP[0])*60; // Взводим насос на десять минут работы
       timeMIXER=(int) tempP[0] *60;        
    }
    
    if (time2==0)
    { 
      time2=(int) timePressNBK*5;
      ProcessPIDPress((int) minPressNBK*5,MaxPressByPeriod);
      
      if (MaxPressByPeriod>(int) minPressNBK*5+(int)deltaPressNBK && minPressNBK>0)
        { // Если превышено давление, то переходим в режим прекращения подачи браги.
          // Если минимальное давление не установлено, то ситуацию игнорируем.
          StateMachine=6;
          time2=((int) timePressNBK*5)/8;  
          if (BeepStateProcess) my_beep(BEEP_LONG/2);
          break;
        }
      if (MaxPressByPeriod<(int) minPressNBK*5 && deltaPressNBK>0) {SpeedNBKDst++; if (BeepStateProcess) my_beep(BEEP_LONG/2);}
      // Взводим таймер на время, определяемое мощностью регулятора мощности.
      MaxPressByPeriod=U_MPX5010;
    }
    // Если превысило двойную дельту, то не дожидаемся, пока окончится время и сразу переходим в режим превышения по давлению.
    // Если минимальное давление не установлено, то ситуацию игнорируем.
    if (MaxPressByPeriod>(int) minPressNBK*5+(int)deltaPressNBK +(int)deltaPressNBK  && deltaPressNBK>0 && minPressNBK>0)
    {
        StateMachine=6;
        time2=((int) timePressNBK*5)/8;  
        if (BeepStateProcess) my_beep(BEEP_LONG/2);
        break;
    }
    if (SpeedNBKDst>125) SpeedNBKDst=125;
    
    SpeedNBK=SpeedNBKDst;

    if  (temps[TEMP_DEFL]>=980 && time1<=0)
    {
      //Если температура превысила максимальную и с момента старта прошло более 20 минут, то считаем, что произошла авария - заклинил насос или кончилась брага.
      // Ждем 5 минут и завершаем процесс.
      time2=5*60;
      StateMachine=5;
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    break;
  case 5:
    if (SpeedNBKDst>125) SpeedNBKDst=125;
    SpeedNBK=SpeedNBKDst;
    timeNBK=20;

    if  (temps[TEMP_DEFL]<970)
    {  
       StateMachine=4;
    }
    my_beep(BEEP_LONG*3);
    if (time2<=0)
    {
      StateMachine=100;
    }
    break;
  case 6: // Превышение давления, ожидаем снижения давления, подача браги при этом прекращается.
    UstPower=PowerNBK;
    timeNBK=20;
    
    time1=(int) timePressNBK *5 *4; // В процессе превышения давления не анализируем температуру верха колонны в течение четырехкратного периода анализа давления.
    
    // Работаем в следующем режиме - 2 минуты пауза, 1 минута работает миксер.
    if (time3==0) 
    {  
       time3=((int) tempP[0]+ (int) timeP[0])*60; // Взводим насос на десять минут работы
       timeMIXER=(int) tempP[0] *60;        
    }
    
    if (time2==0)
    { 
  
      time2=(int) timePressNBK*5/8;
      ProcessPIDPress((int) minPressNBK*5,MaxPressByPeriod);
      if (MaxPressByPeriod<(int) minPressNBK*5+(int)deltaPressNBK ) // Если давление вернулось в норму, уменьшаем подачу и переходим в режим подачи браги
        { if (deltaPressNBK>0) SpeedNBKDst-=1;
          // Время анализа ставим вдвое меньше, чем на превышение.
          time2=(int) timePressNBK*5/4;
          StateMachine=4;
          if (BeepStateProcess) my_beep(BEEP_LONG/2);
        }
      // Взводим таймер на время, определяемое настройками
      MaxPressByPeriod=U_MPX5010;
    }
    else
     if (U_MPX5010<=(int) minPressNBK*5 || minPressNBK<=0) // Если текущее давление стало меньше или равно минимальному, тогда заканчиваем прекращать подачу браги 
     {                                                     // или если минимальное давление не установлено, что означает отключение его контроля 
        if (deltaPressNBK>0) SpeedNBKDst-=1; 
        // Время анализа ставим вдвое меньше, чем на превышение.
          time2=(int) timePressNBK*5/4;
         StateMachine=4;
         if (BeepStateProcess) my_beep(BEEP_LONG/2);
         MaxPressByPeriod=U_MPX5010;
    }
    
    SpeedNBK=0;
    break;
  
  case 101: // Превышение температуры в ТСА!!!
    break;
    my_beep(3*BEEP_LONG);
  case 100:// Конечное состояние автомата
    SpeedNBK=0;
    timeNBK=0;
    if (StateMachine==100 && BeepEndProcess) my_beep(BEEP_LONG);
    UstPower=0;
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    CloseAllKLP();
//    digitalWrite(PIN_REG_ON,LOW);
    digitalWrite(PIN_RZG_ON,!RELAY_HIGH);
    digitalWrite(PIN_ALL_OFF,ALL_OFF_HIGH);
    flAllOff=1;
    if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
    break;
  }

}

